Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sat Dec 1 06:04:45 2018 +0100

    released 3.4.1
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Simo Sorce <simo@redhat.com>
Date:   Wed Oct 3 13:12:38 2018 -0400

    Constant time/cache PKCS#1 RSA decryption
    
    This patch tries to make the code have the same time and memory access
    aptterns across all branches of the decryption function so that timining
    or cache side channels are minimized or neutralized.
    
    To do so it uses a new nettle rsa decryption function that is
    side-channel silent.
    
    Signed-off-by: Simo Sorce <simo@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Wed Nov 28 16:00:34 2018 +0100

    Added test about rsa decryption under pkcs11
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Fri Nov 30 10:28:28 2018 +0100

    gnutls_x509_crt_set_expiration_time: fixed documentation [ci skip]
    
    Fixed the documentation of the function to reflect reality.
    This function did not accept the GNUTLS_X509_NO_WELL_DEFINED_EXPIRATION
    macro.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Fri Nov 30 08:49:50 2018 +0100

    NEWS: updated [ci skip]
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Fri Nov 30 08:44:35 2018 +0100

    bumped version
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Thu Nov 29 06:05:22 2018 +0300

    tests: attempt to fix test errors on Mac OS X
    
    It looks like Mac OS X's grep has issues with applying basic regexps
    with alternation operator inside. Use several grep calls in pipeline to
    achieve the same result.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Wed Nov 28 23:39:32 2018 +0300

    travis: print logs for all failed tests
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Wed Nov 28 14:10:35 2018 +0300

    lib: fix pkcs11 using defines from PKCS#11 3.0 for EdDSA
    
    pkcs11 support code uses several definitions from forthcoming PKCS#11
    standard version. Older p11-kit versions do not provide these
    definitions. Detect and disable code supporting EdDSA if compiling
    GnuTLS with older p11-kit library.
    
    Closes #626
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
    Fixes: 88377775a3eff679a9ec60ab9bfc6b3c683a0407
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Wed Nov 28 16:03:59 2018 +0300

    tests: fix crl test under MinGW32/64
    
    Use --outfile instead of output redirection to stop CR from sneaking
    into temp file. Extra CR symbols make grep choke on that file.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Stephan Mueller <smueller@chronox.de>
Date:   Tue Nov 27 22:27:26 2018 +0100

    DRBG: Use ACVP validated test vector in self test
    
    Due to removing all of the FIPS 140-2 continuous self test leftovers,
    the DRBG test vector must be updated as the very first DRBG block is not
    dropped any more.
    
    The test complies with the CAVP test definition specified in "The
    NIST SP 800-90A Deterministic Random Bit Generator Validation
    System (DRBGVS)" section 6.2.
    
    The test vector is obtained during a successful trial run using the
    NIST ACVP server. The following registration was used to generate the
    test vector:
    
          {
            "algorithm":"ctrDRBG",
            "prereqVals":[
              {
                "algorithm":"AES",
                "valValue":"same"
              }
            ],
            "predResistanceEnabled":[
              false
            ],
            "reseedImplemented":true,
            "capabilities":[
              {
                "mode":"AES-256",
                "derFuncEnabled":false,
                "entropyInputLen":[
                  384
                ],
                "nonceLen":[
                  0
                ],
                "persoStringLen":[
                  0,
                  256
                ],
                "additionalInputLen":[
                  0,
                  256
                ],
                "returnedBitsLen":512
              }
            ]
          },
    
    Signed-off-by: Stephan Mueller <smueller@chronox.de>

Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Tue Nov 27 13:47:46 2018 +0100

    Fix session description info printing
    
    This fixes a truncation issue in session description information printing
    for certain ciphersuites, and adds a limited testing of expected description
    strings for certain ciphersuites.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Tue Nov 20 11:30:22 2018 +0100

    Prevent applications from combining legacy versions of TLS with TLS1.3
    
    It can happen that an application due to a misconfiguration, enables TLS1.3
    in combination with TLS1.0 or TLS1.1 only. In that case a server which is
    unaware of the TLS1.3 protocol will reply by selecting the TLS1.2 protocol
    instead and that answer will be rejected by the client. With this change
    we ensure that TLS1.3 is not enabled in these problematic scenarios.
    
    Resolves: #621
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Wed Nov 21 18:35:07 2018 +0300

    cert-tests: verify --no-text switch for pkcs7/pkcs12 info
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Fri Nov 16 03:46:52 2018 +0300

    certtool: don't output textual information if --no-text was given
    
    Disable text output if --no-text option was given for --p7-info and
    --p12-info.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Wed Nov 21 20:05:20 2018 +0300

    certtool: don't output pkcs12 information to stderr
    
    Print all pkcs12-info output to outfile, rather than stderr.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Wed Nov 21 18:35:07 2018 +0300

    cert-tests: verify --no-text switch for cert/crq/pub/privkeys
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Fri Nov 16 03:46:52 2018 +0300

    certtool: don't output textual information if --no-text was given
    
    Change privkey/certificate/CRL/CSR handling to disable text output if
    --no-text option was given.
    
    Closes #487
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Stefan Berger <stefanb@linux.vnet.ibm.com>
Date:   Mon Nov 19 11:47:45 2018 -0500

    tests: tpm: Use kill_proc to terminate a process
    
    Use kill_proc to terminate a process by first sending it SIGTERM,
    waiting max. 1 second and then use SIGKILL.
    
    Signed-off-by: Stefan Berger <stefanb@linux.ibm.com>

Author: Stefan Berger <stefanb@linux.vnet.ibm.com>
Date:   Mon Nov 19 11:19:53 2018 -0500

    tests: tpm: Redirect help screen output to stdout
    
    The dash shell doesn't seem to understand &>/dev/null, so use
    >/dev/null to quiet down the help screen check.
    
    Signed-off-by: Stefan Berger <stefanb@linux.ibm.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Sat Nov 24 16:59:12 2018 +0100

    doc: suggest to check max_early_data_size before sending early data
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Thu Nov 22 14:59:54 2018 +0100

    tests: resume: suppress compiler warnings
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Stephan Mueller <smueller@chronox.de>
Date:   Sun Nov 25 13:46:44 2018 +0100

    DRBG: Remove all traces of FIPS 140-2 continuous self test
    
    The removal allows the CAVS / ACVP test required for a successful FIPS
    140-2 validation to pass.
    
    Signed-off-by: Stephan Mueller <smueller@chronox.de>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Thu Nov 22 15:04:00 2018 +0100

    .gitignore: ignore more files and sort them alphabetically
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Tim Rühsen <tim.ruehsen@gmx.de>
Date:   Sat Nov 24 15:58:48 2018 +0100

    bootstrap.conf: add "autogen" to buildreq
    
    Signed-off-by: Tim Rühsen <tim.ruehsen@gmx.de>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Sat Nov 24 15:57:11 2018 +0100

    build: fix srcdir detection when VPATH build
    
    Unlike the ".c.c.bak:" and ".h.h.bak:" rules, ".def.stamp:" needs this
    adjustment because the source files (*.bak) are not provided as $<.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Sat Nov 24 16:00:48 2018 +0100

    tests: remove unnecessary session creation in tls13/anti_replay
    
    This test only checks the behavior of _gnutls_anti_replay_check, thus
    session is not needed at all.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Wed Nov 21 21:09:55 2018 +0100

    doc: corrected typos [ci skip]
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Mon Nov 19 14:16:50 2018 +0100

    tests: added test for RSA decryption under gnutls_privkey_import_ext4
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Mon Nov 19 14:07:39 2018 +0100

    crypto-self-tests-pk: added RSA-PSS sign/verify tests
    
    This also corrects the GOST R 34.10-2012-512-TC26-512-A self
    test.
    
    Relates: #597
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Fri Nov 16 21:04:49 2018 +0100

    tests: added TLS1.3 tests for PKCS#11 and external key types
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Simo Sorce <simo@redhat.com>
Date:   Thu Oct 25 10:03:01 2018 -0400

    Add support for EDDSA/Ed25519 object support via PKCS#11
    
    Tested with softHSM 2.5.0
    
    Resolves #417
    
    Signed-off-by: Simo Sorce <simo@redhat.com>
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Simo Sorce <simo@redhat.com>
Date:   Thu Oct 25 10:44:14 2018 -0400

    Fix RSA-PSS tests to properly return skip value
    
    Signed-off-by: Simo Sorce <simo@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sun Nov 18 20:22:08 2018 +0100

    gnutls_certificate_type_get*: updated documentation to list limitations
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Mon Nov 19 06:50:55 2018 +0100

    tests: resume: use spaces around '?' and ':' according to coding style
    
    Also set a link to the kernel coding style in CONTRIBUTIONS.md
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Wed Nov 14 15:20:08 2018 +0100

    gnutls_certificate_type_get*: ensure that the default type is returned
    
    That is, ensure that unless we negotiate something else than
    X509, the default certificate type is returned to applications.
    Previously we wouldn't do that for TLS1.3 resumed sessions, and
    we would return zero (invalid type) instead.
    
    That addresses issues with applications checking explicitly
    for X509 certificate type being present.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Nov 16 16:13:31 2018 +0100

    tests/tls13-early-data: check if max_early_data_size is advertised
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Nov 16 14:25:49 2018 +0100

    serv: add --maxearlydata option
    
    Also exercise this in testcompat-tls13-openssl.sh.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Sun Nov 18 05:47:08 2018 +0100

    record: gnutls_record_send_early_data: check the upper limit
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Nov 16 16:12:13 2018 +0100

    tls13/session_ticket: fix "max_early_data_size" extension handling
    
    session->security_parameters.max_early_data_size is initially set to 0.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sat Nov 17 19:30:20 2018 +0100

    update documentation on GNUTLS_AUTO_REAUTH and gnutls_record_get_direction [ci skip]
    
    That clarifiesthe intention, and adds warning of using this flag when
    multiple threads are involved. Based on suggestion by Michael Catanzaro.
    
    Relates: #615
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Fri Nov 16 21:16:33 2018 +0100

    .gitlab-ci.yml: run coverage build over fedora
    
    This will include the TPM subsystem in the coverage report.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Stefan Berger <stefanb@linux.vnet.ibm.com>
Date:   Fri Nov 16 10:47:23 2018 -0500

    tests: tpm: Extend test case to not use --register
    
    Extend the tpmtool test case to also test without the --register
    parameter.
    
    Signed-off-by: Stefan Berger <stefanb@linux.ibm.com>

Author: Stefan Berger <stefanb@linux.ibm.com>
Date:   Wed Nov 14 10:07:08 2018 -0500

    tests: tpm: Add a test case for tpmtool
    
    This test case exercises tpmtool and uses certtool to create a
    self-signed certificate with the TPM. It uses swtpm as TPM emulator and
    configures tcsd to talk to swtpm.
    
    Extend the Readme.md with the packages needed for TPM support and TPM test
    support.
    
    This test case needs to be run as root since tcsd needs to be started
    as root.
    
    Signed-off-by: Stefan Berger <stefanb@linux.ibm.com>

Author: Stefan Berger <stefanb@linux.vnet.ibm.com>
Date:   Fri Nov 16 06:48:01 2018 -0500

    .gitlab-ci.yml: copy the log files of minimal.Fedora to the gitlab server
    
    Signed-off-by: Stefan Berger <stefanb@linux.ibm.com>

Author: Stefan Berger <stefanb@linux.vnet.ibm.com>
Date:   Thu Nov 15 19:55:02 2018 -0500

    lib: tpm: Fix a memory leak
    
    Signed-off-by: Stefan Berger <stefanb@linux.ibm.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Fri Nov 16 03:38:38 2018 +0300

    doc: mention GOST private key unmasking and additional format support
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Tue Nov 13 11:25:17 2018 +0300

    cert-tests: test parsing and decoding of GOST private keys
    
    Add a test for parsing and decoding GOST private keys in different
    formats, incuding encrypted keys.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Tue Nov 13 11:23:37 2018 +0300

    certtool: support --pkcs-cipher none
    
    If password is specified on command line currently certtool will always
    output encrypted pkcs8 file. Add `--pkcs-cipher none' allowing one to
    force certtool to output unencrypted private keys.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Tue Nov 13 03:02:35 2018 +0300

    nettle/gost: gostdsa: use size_t instead of mp_limb_t
    
    Use size_t for size variables instead of mp_limb_t (data type rather
    than size type).
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Tue Nov 13 02:48:05 2018 +0300

    pkcs8: support GOST keys without encapsulation
    
    Add support for yet another representation of GOST private keys:
    LE-formatted number encoded into pkcs-8-PrivateKeyInfo.privateKey
    without any additional encapsulation.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Tue Nov 13 02:47:39 2018 +0300

    nettle: unmaks GOST private keys if necessary
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Tue Nov 13 02:45:18 2018 +0300

    nettle/gost: support GOST key unmasking
    
    New Russian reccomendation defines 'key masking' in the form of
    several concatenated numbers, which must be multiplied modulo Q to get
    private key.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Stefan Berger <stefanb@linux.vnet.ibm.com>
Date:   Thu Nov 15 12:43:01 2018 -0500

    tpmtool: Fix a memory leak related to TPM key list
    
    Signed-off-by: Stefan Berger <stefanb@linux.ibm.com>

Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Thu Nov 15 16:03:38 2018 +0100

    updated auto-generated-files
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Wed Nov 14 13:56:52 2018 +0100

    anti_replay: moved new add function into anti_replay structure
    
    The new function was not sharing anything with the existing
    gnutls_db_* backend, and moving it to anti_replay structure
    is more clean and allows for deviations from the old API
    conventions (e.g., now we can pass pointers for efficiency
    and pass the expiration time as part of the call).
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Tue Nov 13 22:49:26 2018 +0100

    _gnutls_x509_read_eddsa_pubkey(): sanity check the input values
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Tue Nov 13 09:24:06 2018 +0100

    gnutls_x509_privkey_import_ecc_raw(): fail on invalid sizes
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sun Nov 11 08:25:56 2018 +0100

    tests: verify whether certificate request levels behave consistently
    
    This verifies whether the behavior of GNUTLS_CERT_IGNORE, GNUTLS_CERT_REQUEST
    and GNUTLS_CERT_REQUIRE is consistent accross protocols.
    
    Relates #615
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sun Nov 11 08:52:13 2018 +0100

    doc: minor updates in elliptic curve documentation
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Wed Nov 14 13:42:01 2018 +0100

    tests: added a test for detecting duplicate early data
    
    Resolves #610
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Wed Nov 14 01:43:05 2018 +0300

    tests: add testfile from RFC4134 Section 4.5
    
    Add test example demonstrating indefinite-length BER encoding of PKCS#7
    data.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Mon Nov 12 03:34:31 2018 +0300

    pkcs7: allow BER encoding when parsing encapContentInfo.eContent
    
    CMS specification explicitly allows BER encoding in CMS files. RFC 4134
    example 4.5 uses BER indefinite encoding.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Wed Nov 14 01:49:08 2018 +0300

    configure.ac: drop obsolete info line
    
    Since 4b567871 there is no `ac_enable_session_tickets` variable, so
    let's drop obsolete remnants.
    
    Closes #616
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
    Noted-by: Dilyan Palauzov

Author: Daiki Ueno <dueno@redhat.com>
Date:   Tue Nov 13 10:07:09 2018 +0100

    build: minor cleanup of mech-list.h generation
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Tue Nov 13 10:02:17 2018 +0100

    README-ci.freebsd.md: require autogen
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Mon Nov 12 13:41:19 2018 +0100

    build: remove autogen .bak files from the repository
    
    While the .bak files are necessary for not requiring autogen on
    deployment environment, they are not needed for development and may
    cause conflict when other developers use different version of
    autogen. This removes those files from the repository and require
    autogen at make dist time.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Mon Nov 12 15:48:44 2018 +0100

    build: use suffix rules for generating .bak files
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Mon Nov 12 15:48:14 2018 +0100

    build: use AM_MISSING_PROG for autogen
    
    That makes error message more friendly when autogen is not installed
    on developing environment.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Stefan Berger <stefanb@linux.vnet.ibm.com>
Date:   Mon Nov 12 09:20:44 2018 -0500

    tpm: Fix memory leak in encode_tpmkey_url
    
    When returning the key URL in encode_tpm_key_url we do not need to allocate
    a separate buffer for the URL since we return the allocated buffer from
    _gnutls_buffer_to_datum().
    
    Signed-off-by: Stefan Berger <stefanb@linux.ibm.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Mon Oct 15 13:35:43 2018 +0200

    doc: mention 0-RTT
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Sun Oct 21 07:34:07 2018 +0200

    serv: enable anti-replay when early data is used
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Oct 19 17:52:48 2018 +0200

    TLS 1.3: implement anti-replay measure using ClientHello recording
    
    This implements ClientHello recording outlined in section 8.2 of RFC
    8446.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Thu Nov 1 15:37:42 2018 +0100

    db: introduce gnutls_db_set_add_function
    
    This adds a way to store an entry if it is not found in the database,
    so that the implementation can provide atomic test-and-set.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Thu Nov 8 17:54:11 2018 +0100

    db: introduce gnutls_db_check_entry_expire_time
    
    This would be particularly useful when the same database is used to
    store long-lived TLS 1.2 session data and short-lived TLS 1.3
    anti-replay entries.  Note that the existing gnutls_db_check_entry
    doesn't fit in this use-case, as it takes gnutls_session_t as the
    argument.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Mon Oct 22 15:26:07 2018 +0200

    tls13/session_ticket: record timestamp in ticket
    
    This is needed for implementing freshness checks outlined in 8.3 of
    RFC 8446.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Thu Nov 8 15:46:42 2018 +0100

    str: suppress compiler warning when time_t is 32-bit
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Mon Oct 22 11:12:02 2018 +0200

    testcompat-tls13-openssl: exercise early data transmission
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Mon Oct 15 11:29:56 2018 +0200

    tests: add tests for early data
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Oct 12 13:33:13 2018 +0200

    cli: add --earlydata option
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Oct 12 13:33:00 2018 +0200

    serv: add --earlydata option
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Oct 12 13:34:21 2018 +0200

    record: introduce new API functions for early data
    
    This introduces gnutls_record_get_max_early_data_size(),
    gnutls_record_send_early_data(), and gnutls_record_recv_early_data()
    functions.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Oct 12 11:45:59 2018 +0200

    handshake: handle early data
    
    This plumbers early data handling in the handshake processes, which
    consists of:
    - traffic key updates taking into account of client_early_traffic_secret
    - early data buffering in both server and client
    - the EndOfEarlyData message handling
    - making use of max_early_data_size extension in NewSessionTicket
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Sun Oct 28 07:57:34 2018 +0100

    session_pack: record max_early_data_size in session data
    
    max_early_data_size sent as part of NST should be recorded and
    restored when the session data is set back on the session.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Sun Oct 28 07:57:57 2018 +0100

    record: fix memleak when rejecting early data
    
    The "discard" label previously used assumes that the decrypted record
    is already added to record_recv_buffer.  It is not the case when
    rejecting early data.  Release the allocated memory manually and
    return early.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Oct 12 17:10:51 2018 +0200

    constate: add epoch_rel argument to _gnutls_epoch_dup
    
    This is necessary for handling early data.  Previously,
    _gnutls_epoch_dup() copied the parameters from EPOCH_READ_CURRENT,
    while the client only sets EPOCH_WRITE_CURRENT when sending early
    data.  This allows caller to specify from which epoch the parameters
    are copied.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Oct 12 11:29:57 2018 +0200

    handshake: refactor early secret derivation
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Oct 5 10:41:23 2018 +0200

    handshake: record transcript hash for ClientHello
    
    This is necessary to compute client_early_traffic_secret and
    early_exporter_master_secret in TLS 1.3.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <dueno@redhat.com>
Date:   Fri Oct 5 11:13:24 2018 +0200

    ext/pre_shared_key: use predefined macros for secret labels
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Tim Rühsen <tim.ruehsen@gmx.de>
Date:   Tue Nov 6 09:38:43 2018 +0100

    Unconditionally include nettle/memxor.h
    
    Signed-off-by: Tim Rühsen <tim.ruehsen@gmx.de>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sat Nov 10 10:54:32 2018 +0100

    gnutls-cli: use assert to mark impossible path
    
    This avoids static analyzers from complaining.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sat Nov 10 07:46:24 2018 +0100

    pkcs12: cleanups, and two memory leak fixes
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Fri Nov 9 07:44:02 2018 +0100

    tls13: use system's openssl for interop testing
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Fri Nov 9 20:11:42 2018 +0100

    Added checks to avoid false negatives reported by static analyzers
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Tue Nov 6 14:47:41 2018 +0300

    src: update autogenerated .bak files
    
    Update files to include proper year, version, etc.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Tue Nov 6 14:42:56 2018 +0300

    src: include .bak files in EXTRA_DIST
    
    Including .bak files in EXTRA_DIST allows us to stop hand-generating
    these files in distribution. Instead they are directly copied from the
    source tree.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Tue Nov 6 14:34:18 2018 +0300

    src: update .bak files during -args.c/.h regeneration
    
    To ease updating of .bak files, update them when regenerating
    Autogen'erated source files.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Tue Nov 6 12:01:49 2018 +0300

    doc: fix texi generation in out-of-tree builds
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Tue Nov 6 10:52:47 2018 +0300

    src: mark autogen'ed sources as nodist_
    
    Mark autogenerated sources as not distributable. We are distributing
    .bak files instead.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Mon Nov 5 16:37:02 2018 +0300

    Makefile.am: drop manpages regeneration from dist-hook
    
    There is no need anymore to regenerate tools manpages, they will be
    generated automatically from doc/manpages/Makefile.am.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Mon Nov 5 16:22:25 2018 +0300

    manpages: fix manpages distribution
    
    It seems that dist_man_MANS does not work properly with Automake
    conditionals. Automake will not distribute files which are conditionally
    disabled at this make run. As released tarballs include all manpages
    already, let's include them unconditionally.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Mon Nov 5 15:02:50 2018 +0300

    manpages: fix tools manpages generation
    
    Pass additional include path to let autogen find common arguments
    template.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   Mon Nov 5 14:53:46 2018 +0300

    manpages: un-unroll the loop
    
    Replace unrolled loop over header files with for-loop to simplify
    Makefile.
